#ifndef _DJR_SIMPLETEXMNGR_H_
#define _DJR_SIMPLETEXMNGR_H_

#include <sps2lib.h>
#include "UsefulMacros.h"

// TEMPORARY!
#define TEX_W 256
#define TEX_H 256
#define TEX_DEPTH 4
#define TEX_NUM_PIX (TEX_W * TEX_H)
#define TEX_SIZE (TEX_NUM_PIX * TEX_DEPTH)
#define MAX_TX_QW ((4096 / 16) - 1)
#define MAX_TEXTURE_SLOTS 4

// a hint as to what textures we can dump and which need to stay loaded
typedef enum
{
  TEX_PRI_USE_ONCE,
  TEX_PRI_TEMPORARY,
  TEX_PRI_NEVER_DUMP,
  TEX_PRI_MAX,
}TexturePriority;

typedef struct
{
  char sName[ 32 ];                // just to help with debugging
  sps2uint32 uGSMemAddr;  // gs memory address in words
  sps2uint32 bUsed;             // is there a texture in this slot?
  sps2uint32 uNumTextels;
  TexturePriority ePriority;
  unsigned long long uRefCount;
}TextureSlot;

void SimpleTexMngrInit( int iSPS2Device );
void SimpleTexMngrKill( void );
sps2uint32 GetSlotGSAddress( int iSlot );
Bool UploadTexToGS( char *sFileName, int iRequestedSlot, 
		    TexturePriority ePriority, char *sDesc );
int DrawTexturedSprite( int ulx, int uly, int llx, int lly,
                        int lrx, int lry, int urx, int ury,
			unsigned int tw, unsigned int th, 
			int iTextureSlot );

#endif
