#include "sps2registers.h"
#include "sps2lib.h"
#include "DJR_Timers.h"

/*******************************************************/
void SetTimer( float fSeconds )
{
  TnMode mode;
  mode.CLKS = 2; // 1/256 of 147.456MHz
  mode.GATE = 0; // gate is unused
  mode.GATS = 0;
  mode.GATM = 0;
  mode.ZRET = 1; // counter goes back to zero after hitting reference value
  mode.CUE = 1;  // start counting
  mode.CMPE = 1; // generate a compare interrupt
  mode.OVFE = 0; // no overflow interrupt
  mode.EQUF = 1; // clear the equal flag
  mode.OVFF = 1; // clear the overflow flag
  mode.DUMMY = 0;  

  // when CLKS = 2, we get 576,000 ticks per second
  (*(EE_T1_COMP)) = (int)( TICKS_PER_SECOND * fSeconds );
  
  volatile unsigned int *iMode = (volatile unsigned int *)&mode;
  *(EE_T1_MODE) = *iMode;
}

/*******************************************************/
Bool DidTimerExpire( void )
{
  TnMode mode;

  mode = *((TnMode *)(EE_T1_MODE));
  return( mode.EQUF );
}

/*******************************************************/
float GetTimerInSeconds( void )
{
  int iTicks;

  iTicks = *(EE_T1_COUNT);
  return( iTicks / TICKS_PER_SECOND );
}


