#ifndef _USEFULMACROS_H_
#define _USEFULMACROS_H_

#include <stdint.h>
#include <endian.h>
#include <sps2types.h>

typedef  uint8_t BYTE; 
typedef uint32_t DWORD;
typedef uint32_t Bool;

#define TRUE 1
#define FALSE 0

#if BYTE_ORDER == BIG_ENDIAN
#define SHORT_SWAP(x) (((x & 0xFF00) >> 8) | ((x & 0x00FF) << 8)) 
#elif BYTE_ORDER == LITTLE_ENDIAN
#define SHORT_SWAP(x) x
#endif

#define PIOVER180 ( 3.14159265f / 180.f )
#define ROT_2D_X( x, y, rad ) ( cosf( rad ) * x - sinf( rad ) * y )
#define ROT_2D_Y( x, y, rad ) ( sinf( rad ) * x + cosf( rad ) * y )

#define SYS_ASSERT(x)
#define CLIP_VALU(l, x, h) x<(l)? x=(l) : (x>(h)? x=(h) : x=x);
#define EQUAL_TOLERANCE 0.0001f
#define IS_EQUAL(x,y) (x<= y+EQUAL_TOLERANCE && x>= y-EQUAL_TOLERANCE)
#define ROUND(x) (int)(x+0.5f)
#define BETWEEN(a,x,b) (a < b? (x>=a && x<=b) : (x>=b && x<=a))

#define TVAL_DIFF(t0, t1) ((t1.tv_sec + t1.tv_usec*.000001)-(t0.tv_sec + t0.tv_usec*.000001))
#define TVAL_IN_USEC(t0) (t0.tv_usec + t0.tv_sec * 1000000)

#endif

